! hBasic console demo v4.13.00

MENU.SET ""
CONSOLE.TITLE "",,"BLACK"
CONSOLE.SET~
	"wrap off",~
	"SPACING 1",~
	"DIVIDERS Off",~
	"TEXTCOLOR LIGHTGREY",~
	"BACKCOLOR black",~
	"VOIDCOLOR black",~
	"TITLE COLORS"
GOSUB init
?:?
PAUSE 2000
for i=3 to 6			% zoom on
 .cs "TEXTSIZE "+int$(i*3)
 print.at i,6;"From"
 pause 100
next
.cs "TEXTSIZE 20"
print.at 7,7;"From"
for i=3 to 6			% zoom off
 .cs "TEXTSIZE "+int$(i*3)
 print.at i,6;"    "
 pause 100
next
.cs "TEXTSIZE 20"
blink_ (7,11,5)

.cs "TEXTSIZE 20"
slideprint (7,12,"The Depths")
slideprint (8,12,"of Space..")
blink_ (8,22,4)

wipeline (7,8)
pause 2000
cls
.cs "FONT "+bitwise$
.cs "TEXTSIZE 30"
?.at 4,1;""			% need pre-black lines
.cs "textcolor black, backCOLOR NeonGreen"
slowprint (4,6, "hSoft", 200)
blink (4,11,"NeonGreen","black",4)

.cs "BACKCOLOR ORANGE, TEXTCOLOR BLACK"
.cs "TEXTSIZE 24"
slowprint (4,13, "Presents", 200)
blink (4,21,"ORANGE","black",4)
pause 1000
.cs "BACKCOLOR BLACK, TEXTCOLOR WHITE"
.cs "TEXTCOLOR white.50"
.cs "TEXTSIZE 38"
for i=1 to 255 step 15		% fade
	.cs "TEXTCOLOR white."+int$(i)
	.cs "FONT "+glam$
	print.at  6,8; "hBasic"
	.cs "FONT "+ghost$+".italic"
	.cs "TEXTCOLOR gold."+int$(i)
	print.at  6,15; "demo"
	pause 100
next
pause 1000
.cs "TEXTSIZE 28"
.cs "TEXTCOLOR cyan"
.cs "FONT "+glam$+".BOLD"
slideWord (7,9,"04.13+")
pause 2000
!----------------------------------------
.cs "TEXTSIZE 18"
.cs "FONT "+army$
print		% line 8 & 9 needs to be black
print
.cs "TEXTCOLOR white, BACKCOLOR black"
slowprint (9,1,"Warping to Part ", 30)
.cs "FONT monospace"
print.at -1,17;"2..."

GOSUB BUSY
.cs "FONT Monospace"
.cs "TEXTSIZE 18"
.cs "TEXTCOLOR white, BACKCOLOR black"
cls
call WarpOut()
RUN "font-fam.bas", "FONTLOAD"
goto fin
!----------------------------------------
busy :
 i = 1
 FOR b = 1 TO 4
  BACKSPACE
  PRINT twidle$[i]
  IF ++i > 3 THEN i=1
  PAUSE 1000	% pretend to do something
  busy++
  IF busy > 4 THEN busy = 0
 NEXT b
 BACKSPACE	% clear twidle
 PRINT "OK."
RETURN
!----------------------------------------
init:
fn.def slowprint (y,x, s$, delay)
 x--
 l = len (s$)
 for i = 1 to l
  c$ = chr$(ascii(s$,i))
  PRINT.AT y,x+i; c$
  pause delay
 next
fn.end
%--------------
fn.def slidePrint (y,x,s$)
 x--
 delay = 10
 scr_end = 30
 l = len (s$)
 for i = 1 to l
  c$ = chr$(ascii(s$,i)) + " "
  if c$="  " then f_n.continue
  for j = scr_end to x+i step -1
   PRINT.AT y,j; c$
   pause delay
  next j
  delay++
 next i
fn.end
%--------------
fn.def slideWord (y,x,s$)
 delay = 100
 b$ = chr$(hex("3000"))
 for i = 1 to x-1
   PRINT.AT y,i; b$+s$		
   pause delay
 next i
 for i=1 to 3
  PRINT.AT y,x; b$+s$		% overshoot
  pause 30
  PRINT.AT y,x;  s$+b$		% correct overshoot
  pause 30
  PRINT.AT y,x-1;s$+b$		% undershoot
  pause 30
  PRINT.AT y,x-1;  b$+s$	% correct undershoot
  pause 30
 next i
fn.end
%--------------
fn.def wipeline (f,t)
	for i=1 to 30
	 for j=f to t
		print.at j,i;" "
	 next j
	pause 10
	next
fn.end
%--------------
fn.def blink_ (y,x, n)

	for i=1 to n
		print.at y,x;"_"
		pause 200
		print.at y,x;" "
		pause 200
	next
fn.end
%--------------
fn.def blink(y,x,on$,off$,n)
	
	for i=1 to n*2
		.cs "textcolor "+off$+", backcolor "+on$
		print.at y,x;" "
		swap on$,off$
		pause 200
	next
fn.end
%--------------
fn.def drawFrame(l,t,r,b)

	if l>=r | t>=b-1  then fn.rtn t
	tl$="+" : tr$="+" : bl$="+": br$="+"
	hl$="-" : vc$="|"

	print.at t,l;tl$		% corners
	print.at t,r;tr$
	print.at b,l;bl$
	print.at b,r;br$

	for i=l+1 to r-1		% horizontals
		?.at t,i;hl$
		?.at b,i;hl$
	next
	for i=t+1 to b-1		% verticals
		?.at i,l;vc$
		?.at i,r;vc$
	next
	fn.rtn 0
fn.end
%--------------
fn.def WarpOut()
	CONSOLE.SCREEN sw,sh
	sh--
	l=1 : t=1 : r=int(sw) : b=int(sh)
	delay=50

	for i=1 to sh/2
		drawFrame(l++,t++,r--,b--)
		pause delay
	next
	.cs "TEXTCOLOR BLACK"
	l=1 : t=1 : r=int(sw) : b=int(sh)
	for i=1 to sh/2
		drawFrame(l++,t++,r--,b--)
		pause delay
	next
	cls
	.cs "TEXTCOLOR white"
	?.at sh/2+1,sw/2;  "*"
	pause 2000
	cls
fn.end
%--------------
ARRAY.LOAD twidle$[], "-", "\\", "|", "/"
FONT.LOAD fptr_bitwise, "../source/bitwise.ttf"
FONT.LOAD fptr_ghost, "../source/Ghost_theory_2.ttf"
FONT.LOAD fptr_army, "../source/army.ttf"
FONT.LOAD fptr_glam, "../source/sg.ttf"
bitwise$ = int$(fptr_bitwise)
ghost$   = int$(fptr_ghost)
army$   = int$(fptr_army)
glam$   = int$(fptr_glam)
!---------------------------------------------
RETURN %_init
fin:
